(ql:quickload :cffi)

(cffi:define-foreign-library (mydll :type :test)
  (:windows "mydll.dll")
  (t (:default "mydll")))

(defun load-directory ()
  (let ((here #.(or *compile-file-truename* *load-truename*)))
    (make-pathname :name nil :type nil :version nil
                   :defaults here)))

(let ((cffi:*foreign-library-directories* (list (load-directory))))
   (cffi:load-foreign-library 'mydll))

(cffi:defcfun "call_me" :void (f :pointer))

(cffi:defcallback locking-callback :void
    ((mode :int)
     (n :int)
     (file :string)
     (line :int))
  ;(declare (ignore file line))
;(format t "-> ~%")
;(format t "   ~A ~A ~A ~A ~A ~A~%" mode n file line (incf *lock-counter*) (bt:current-thread))
  ;; (assert (logtest mode (logior +CRYPTO-READ+ +CRYPTO-WRITE+)))

;(format t "<- ~%")
)

(terpri)
(format t "preforming the callback test...~%")

(call-me (cffi:callback locking-callback))

(format t "done~%")
